#!/bin/sh
# This script is primarily to be used in crontab
# It calls other scripts to do data collecting and indexing,
# then it rebuilds the result of hotest queries into the cache.

PATH=/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/usr/ucb:/usr/5bin:/bin; export PATH
#CGI not allowed
if [ ! -z "$REMOTE_ADDR" ]; then
  exit
fi

# proxy server setting for flcollect.pl
# uncomment below line if you want ftplocate to use proxy for http
#
# http_proxy="http://your_proxy_server:3128/"; export http_proxy


CREATED=''

cd /usr/local/www/cgi-bin/ftplocate

if [ ! -d filelist ] ; then
  mkdir filelist
fi
if [ ! -d desc ] ; then
  mkdir desc
fi
if [ ! -d cache ]; then
  mkdir cache
  CREATED="$CREATED /usr/local/www/cgi-bin/ftplocate/cache"
fi
if [ ! -d /tmp ]; then
  mkdir /tmp
  CREATED="$CREATED /tmp"
fi
if [ ! -f log.system ]; then
  touch log.system
fi
if [ ! -f log.user ]; then
  touch log.user
  CREATED="$CREATED /usr/local/www/cgi-bin/ftplocate/log.user"
fi
if [ ! -f log.map ]; then
  touch log.map
fi

#chown www cache log.system log.user log.map 
if [ ! -z "$CREATED" ]; then
   echo Please be sure that your CGI process has enough privilege 
   echo to write the following location:
   echo $CREATED
   echo then Run the index.sh again
   exit 1
fi


if ! ./flcollect.pl $*; then
  exit $?
fi
if ! ./flindex.pl $*; then
  exit $?
fi
if ! ./dcollect.pl; then
  exit $?
fi
if ! ./dindex.pl; then
  exit $?
fi

./fltop.pl 50|./fltrain.pl
rm /tmp/*tmp.[0-9]* /tmp/.*tmp.[0-9]* 2>/dev/null
exit 0
